#!/bin/bash

##
# This script is used to run the test client applications.
# Call this script with the name of the client application you wish
# to run.
#          ex: ./runtest.sh GetOpportunitiesClient url=https://10.222.134.101:8002 cfda=00.000
#          ex: ./runtest.sh GetOpportunitiesClient url=https://10.222.134.101:8002 cfda=00.000 compid=1234
#
# Listed below are test names that you can run.
#
# GetOpportunitiesClient url=http://testws.grants.gov:8002 cfda=00.000
#
##

##
# Variables that you should change to suit your environment.
##

# JAVA_HOME
export JAVA_HOME=/opt/weblogic/jdk160_29   
echo "JAVA_HOME: " ${JAVA_HOME}
$JAVA_HOME/bin/java -version

# REFIMPL=..
export REFIMPL=../ApplicantClient_CL
echo "REFIMPL="${REFIMPL}
echo ""

#DIST_DIR=${REFIMPL}/dist
export DIST_DIR=.
echo "DIST_DIR="${DIST_DIR}
echo ""

#LIB=${REFIMPL}/lib
#CLIENTJAR=${REFIMPL}/dist/applicant-s2s-client.jar
export LIB=lib
#CLIENT_JAR=${LIB}/app-s2s-client.jar

# windoze classpath separator
# CP_SEP=';'
# UNIX classpath separator
export CP_SEP=':'

# Toggle this variable to point to the package coresponds to the RI you would like to test.
export PACKAGE=gov.grants.apply.applicant.v1


# Execute the Test script.

./run.sh $*